// EditAdjacetTerr.cpp : implementation file
//

#include "stdafx.h"
#include "riskedit.h"
#include "EditAdjacetTerr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditAdjacetTerr dialog


CEditAdjacetTerr::CEditAdjacetTerr(CWnd* pParent /*=NULL*/)
	: CDialog(CEditAdjacetTerr::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditAdjacetTerr)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pAdjTerrList = 0;
	m_pTLend = 0;
	m_pCurTerr = 0;
	this->m_pMT_Init = 0;
	this->m_pMC_Init = 0;
}


void CEditAdjacetTerr::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditAdjacetTerr)
	DDX_Control(pDX, IDC_LIST_ADJ_TERR_LIST, m_List_TerrList);
	DDX_Control(pDX, IDC_LIST_ADJ_TERR, m_List_Terr);
	DDX_Control(pDX, IDC_LIST_ADJ_SEL_TERR, m_List_SelTerr);
	DDX_Control(pDX, IDC_LIST_ADJ_SEL_CONT, m_List_SelCont);
	DDX_Control(pDX, IDC_LIST_ADJ_CONT, m_List_Cont);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditAdjacetTerr, CDialog)
	//{{AFX_MSG_MAP(CEditAdjacetTerr)
	ON_LBN_DBLCLK(IDC_LIST_ADJ_CONT, OnDblclkListAdjCont)
	ON_LBN_DBLCLK(IDC_LIST_ADJ_SEL_CONT, OnDblclkListAdjSelCont)
	ON_LBN_DBLCLK(IDC_LIST_ADJ_SEL_TERR, OnDblclkListAdjSelTerr)
	ON_LBN_DBLCLK(IDC_LIST_ADJ_TERR, OnDblclkListAdjTerr)
	ON_LBN_DBLCLK(IDC_LIST_ADJ_TERR_LIST, OnDblclkListAdjTerrList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditAdjacetTerr message handlers

BOOL CEditAdjacetTerr::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	CMapContinent *pC = (CMapContinent *)m_pMap->GetChild();
	///---------------------------------------
	///First fill in the Continent Lists
	///-------------------------------------
	while(pC)
	{
		m_List_Cont.AddString(pC->GetName());
		m_List_SelCont.AddString(pC->GetName());
		pC = (CMapContinent *)pC->GetNext();
	}
	if(m_pMC_Init)
	{
		m_List_Cont.SelectString(0,m_pMC_Init->GetName());
		if(m_pMT_Init)
		{
			CMapTerritory *pT;
			pT = (CMapTerritory *)m_pMC_Init->GetChild();
			while(pT)
			{
				m_List_Terr.AddString(pT->GetName());
				pT = (CMapTerritory *)pT->GetNext();
			}
			m_List_Terr.SelectString(0,m_pMT_Init->GetName());
			CTerrList *pTL = m_pMT_Init->GetNieghborList();
			while(pTL)
			{
				m_List_TerrList.AddString(pTL->GetTerr()->GetName());
				pTL = pTL->GetNext();
			}
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditAdjacetTerr::OnDblclkListAdjCont()
{
	/******************************************
	** Message Handler OnDblclkListAdjCont
	**
	** This function handles a double click
	** Message for the List box that will select
	** the continent that the territory is in
	** that we want to connect to other territories
	******************************************/
	// TODO: Add your control notification handler code here
	int sel = m_List_Cont.GetCurSel();
	char *s = new char[256];
	m_List_Cont.GetText(sel,s);
	CMapContinent *pMC = FindContinent(s,(CMapContinent *)this->m_pMap->GetChild());
	CMapTerritory *pT = (CMapTerritory *)pMC->GetChild();
	if(m_pCurTerr)
	{
		if(m_pCurTerr != pT)	//UPDATE Old current terrotry
		{
		}
	}
	ClearListBox(&m_List_Terr);
	while(pT)
	{
		m_List_Terr.AddString(pT->GetName());
		pT = (CMapTerritory *)pT->GetNext();
	}
	delete[] s;
}

void CEditAdjacetTerr::OnDblclkListAdjSelCont()
{
	/*****************************************
	** Message Handler OnDblclkListAdjSelCont
	**	This function handles messages for
	** the list box that will select the
	** continent that contains the territories
	** that we want to connect to.
	*****************************************/
	// TODO: Add your control notification handler code here

	int sel = m_List_SelCont.GetCurSel();
	char *s = new char[256];
	m_List_SelCont.GetText(sel,s);
	CMapContinent *pMC = FindContinent(s,(CMapContinent *)this->m_pMap->GetChild());
	CMapTerritory *pT = (CMapTerritory *)pMC->GetChild();
	ClearListBox(&m_List_SelTerr);
	while(pT)
	{
		m_List_SelTerr.AddString(pT->GetName());
		pT = (CMapTerritory *)pT->GetNext();
	}
	delete[] s;
}

void CEditAdjacetTerr::OnDblclkListAdjSelTerr()
{
	/***************************************************
	** Message Handler OnDblclkListAdjSelTerr
	**	This list box has the list of territories that
	** we can select from to connect to the one.  When
	** we double click on the territory, it is added to
	** the Territory List box.
	***************************************************/
	// TODO: Add your control notification handler code here
	int sel = m_List_SelTerr.GetCurSel();
	char *s = new char[256];
	m_List_SelTerr.GetText(sel,s);
	m_List_TerrList.AddString(s);
	delete[] s;
}

void CEditAdjacetTerr::OnDblclkListAdjTerr()
{
	/*******************************************
	** Message Handler OnDblclkListAdjTerr
	** This Listbox contains a list of territories
	** that we will be connect to other territories.
	** When we double click we can find out
	** what is already connected, and if we
	** double click on a different territory
	** we save the infor for the previous
	** territory, and then display the new
	** one.
	*******************************************/
	// TODO: Add your control notification handler code here
	CTerrList *pTL;
	CMapTerritory *pT = GetCurTerritory();
	if(m_pCurTerr)
	{
		if(m_pCurTerr != pT)	//UPDATE Old current terrotry
		{
			UpdateTerritoryList(m_pCurTerr);
			m_pCurTerr = pT;
		}
	}
	else m_pCurTerr = pT;

	pTL = pT->GetNieghborList();
	ClearListBox(&m_List_TerrList);
	while(pTL)
	{
		m_List_TerrList.AddString(pTL->GetTerr()->GetName());
		pTL = pTL->GetNext();
	}
}

void CEditAdjacetTerr::OnDblclkListAdjTerrList()
{
	/******************************************
	** Message Handler OnDblclkListAdjTerrList
	**	The only thing we do with this List Box
	** is delete an item.
	******************************************/
	// TODO: Add your control notification handler code here
	int sel = m_List_TerrList.GetCurSel();
	m_List_TerrList.DeleteString(sel);
}

CMapContinent * CEditAdjacetTerr::FindContinent(char *s,CMapContinent *pMC )
{
	/************************************
	** FindContinent
	**
	** This function locates and returns
	** a pointer to a specific continent from
	** a list of continents
	**
	** parameters:
	**	s......name of continent to search for
	** 	pMC....pointer to list of continents
	**
	** Returns:NULL if not found, pointer
	** to continent otherwise.
	******************************************/
	int loop = 1;
	///loop until we find it or run out of data
	while(pMC && loop)
	{
		if(strcmp(s,pMC->GetName()) == 0) loop = 0;
		else
			pMC = (CMapContinent *)pMC->GetNext();
	}
	return pMC;

}

void CEditAdjacetTerr::ClearListBox(CListBox *pLB)
{
	/***************************************************
	** ClearListBox
	**
	** this function is used to clear all the
	** entries in a list box.
	**
	** parameter:
	**	pLB......pointer to the list box object to clear
	***************************************************/
	int i;
	int n = pLB->GetCount();
	if(n)
	{
		for(i=0;i<n;++i)
			pLB->DeleteString(n-i-1);
	}

}

void CEditAdjacetTerr::OnOK()
{
	// TODO: Add extra validation here
	CMapTerritory *pTsel;
	pTsel = GetCurTerritory();
	UpdateTerritoryList(pTsel);
	CDialog::OnOK();
}

CMapTerritory * CEditAdjacetTerr::FindTerritory(CMapContinent *pMC, char *s)
{
	/**************************************************
	** FindTerritory
	**
	** This function is used to find a specific
	** territory, by name, from a list of continents
	**
	** parameters:
	**	pMC.....pointer to a list of continents
	**	s.......Name of terriroty to find
	**
	** Returns:
	**	NULL   if name does not match a territory
	**	or a Pointer to found CMapTerritory.
	**************************************************/
	int loop=1;
	CMapTerritory *pT,*pTrV=0;

	while(pMC && loop)
	{
		pT = (CMapTerritory *)pMC->GetChild();
		while(pT && loop)
		{
			if(strcmp(s,pT->GetName()) == 0)	//found it
			{
				pTrV = pT;
				loop = 0;
			}
			else
				pT = (CMapTerritory *)pT->GetNext();
		}
		pMC = (CMapContinent *)pMC->GetNext();
	}
	return pTrV;
}

CMapContinent * CEditAdjacetTerr::GetCurContinent()
{
	/***********************************************
	**  GetCurContinent
	**
	**	Returns a pointer to the Current Continent
	** that contains the territory that is having
	** neighbors added to it.
	**
	** Returns a pointer to the current continent
	***********************************************/
	int sel;
	char *s = new char[256];
	CMapContinent *pMC = (CMapContinent *)m_pMap->GetChild();
	sel = m_List_Cont.GetCurSel();
	m_List_Cont.GetText(sel,s);
	pMC = FindContinent(s,pMC);
	delete[] s;
	return pMC;
}

CMapTerritory * CEditAdjacetTerr::GetCurTerritory()
{
	/***********************************************
	** GetCurTerritory
	**
	** This function returns a pointer to the current
	** territory that we are adding adjacent neighbors
	** to.
	**
	** RETURNS:pointer to the current territory
	***********************************************/
	int sel = m_List_Terr.GetCurSel();
	char *s = new char[256];
	m_List_Terr.GetText(sel,s);
	CMapContinent *pMC = (CMapContinent *)m_pMap->GetChild();
	CMapTerritory *pT = FindTerritory(pMC,s);
	delete[] s;
	return pT;
}

void CEditAdjacetTerr::UpdateTerritoryList(CMapTerritory *pMT)
{
	/***************************************************
	** UpdateTerritoryList
	** This function is used to update the adjacent
	** territory list for a CMapTerritory object.
	** It starts from scratch.  It deletes the
	** current list, and then adds a new list
	** created from the List Box that contains
	** the list of adjacent territories.
	**
	** Parameters:
	**	pMT.....Territory object to update
	***************************************************/
	int n,i;
	char *s = new char[256];
	CMapContinent *pMC;
	CMapTerritory *pT;
	CTerrList *pTL = 0;
	CTerrList *pL;

	//---------------------------------------
	// Get the head of the continent list
	//---------------------------------------
	pMC = (CMapContinent *)m_pMap->GetChild();
	//------------------------------------
	// get the territory that will recive
	// the adjacent territory list
	//-------------------------------------
	pTL = pMT->GetNieghborList();
	if(pTL)	//if there is a list, make a new one
	{
		while(pTL)
		{
			CTerrList *pN = pTL->GetNext();
			delete pTL;
			pTL = pN;
		}
	}
	pTL = NULL;
	n = m_List_TerrList.GetCount();
	if(n)	//any items in list?
	{
		for(i=0;i<n;++i)
		{
			m_List_TerrList.GetText(i,s);
			pT = FindTerritory(pMC,s);
			if(pTL)
			{
				pL->SetNext(new CTerrList);
				pL = pL->GetNext();
				pL->SetTerr(pT);
			}
			else
			{
				pTL = new CTerrList;
				pL = pTL;
				pL->SetTerr(pT);
			}
		}
		pMT->SetNieghborList(pTL);
	}
	else
	{
		pMT->SetNieghborList(NULL);
	}
	delete[] s;
}
