// EditContinents.cpp : implementation file
//

#include "stdafx.h"
#include "riskedit.h"
#include "EditContinents.h"
#include "EditTerritories.h"
#include "Mapcontinent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditContinents dialog


CEditContinents::CEditContinents(CWnd* pParent /*=NULL*/)
	: CDialog(CEditContinents::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditContinents)
	//}}AFX_DATA_INIT
	m_pContEnd = 0;
}


void CEditContinents::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditContinents)
	DDX_Control(pDX, IDC_LIST_CON, m_ListBox_List);
	DDX_Control(pDX, IDC_EDIT_CONT_VALUE, m_Edit_Value);
	DDX_Control(pDX, IDC_EDIT_CONT_NAME, m_Ecit_Name);
	DDX_Control(pDX, IDC_BUTTON_CONT_TERR, m_Button_Terr);
	DDX_Control(pDX, IDC_BUTTON_CONT_ADD, m_Button_Add);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditContinents, CDialog)
	//{{AFX_MSG_MAP(CEditContinents)
	ON_BN_CLICKED(IDC_BUTTON_CONT_TERR, OnButtonContTerr)
	ON_BN_CLICKED(IDC_BUTTON_CONT_ADD, OnButtonContAdd)
	ON_LBN_SELCHANGE(IDC_LIST_CON, OnSelchangeListCon)
	ON_LBN_DBLCLK(IDC_LIST_CON, OnDblclkListCon)
	ON_BN_CLICKED(IDC_BUTTON_CONT_UPDATE, OnButtonContUpdate)
	ON_BN_CLICKED(IDC_BUTTON_CONT_DEL, OnButtonContDel)
	ON_BN_CLICKED(IDC_BUTTON_CONT_DEBUG, OnButtonContDebug)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditContinents message handlers

void CEditContinents::OnOK()
{
	// TODO: Add extra validation here

	CWnd *wC;
	char *s = new char[256];

	///locate control that has gocus
	wC = GetFocus();
	/// Get the ID of that control
	int id = wC->GetDlgCtrlID();
	switch(id)							///parse the id
	{
		case IDOK:
			CDialog::OnOK();
			break;
		case IDC_EDIT_CONT_NAME:
			wC = GetNextDlgTabItem(wC);	///set the focus to next control
			wC->SetFocus();
			break;
		case IDC_EDIT_CONT_VALUE:	///add on this being entered
			m_Ecit_Name.GetWindowText(s,255);	///Get the name
			m_ListBox_List.AddString(s);
			m_Ecit_Name.SetWindowText("");
			/******************************
				Add this continent to the
				data base
			******************************/
			if(m_pMap->GetChild() == NULL)
			{
				//----------------------
				// No continents in map
				// YET
				//----------------------
				CMapContinent *pMC;
				pMC = new CMapContinent;
				m_pMap->SetChild(pMC);	//create new continent
				pMC->SetName(s);			//set continent name
				m_Edit_Value.GetWindowText(s,255);
				m_Edit_Value.SetWindowText("");
				pMC->SetValue(atoi(s));
			}
			else	//not the first
			{
				if(m_pContEnd == NULL)	//2nd time thru?
				{
					//find end of chain
					m_pContEnd = (CMapContinent *)m_pMap->GetChild();
					while(m_pContEnd->GetNext())
						m_pContEnd = (CMapContinent *)m_pContEnd->GetNext();
				}
				//create new continent object
				CMapContinent *pMC;
				pMC = new CMapContinent;
				m_pContEnd->SetNext(pMC);
				pMC->SetName(s);			//set continent name
				m_Edit_Value.GetWindowText(s,255);
				m_Edit_Value.SetWindowText("");
				pMC->SetValue(atoi(s));
				m_pContEnd = pMC;
			}
			wC = GetNextDlgTabItem(wC);	//reset the focus
			wC->SetFocus();
			break;
		default:
			wC = GetNextDlgTabItem(wC);	//reset the focus
			wC->SetFocus();
			break;
	}
	delete[] s;
}

BOOL CEditContinents::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	if(m_pMap->GetChild())	//are there continents?
	{
		CMapContinent *pMC = (CMapContinent *)m_pMap->GetChild();
		while(pMC)	///goe through list and add all continents
		{
			m_ListBox_List.AddString(pMC->GetName());
			pMC = (CMapContinent *)pMC->GetNext();
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditContinents::OnButtonContTerr()
{
	// TODO: Add your control notification handler code here
	///-----------------------------------
	/// Edit the territories associated with
	/// with this continent
	///-----------------------------------
	int sel = m_ListBox_List.GetCurSel();
	if(sel < 0)
		MessageBox("Please Select a Continent to add Territories to","Oppsie");
	else
	{
		char *s = new char[256];
		m_ListBox_List.GetText(sel,s);	///get selected continent

		CEditTerritories *pDlg;
		pDlg = new CEditTerritories;
		pDlg->AddContinentName(s);

		pDlg->DoModal();
		delete[] s;
		delete pDlg;
	}

}

void CEditContinents::OnButtonContAdd()
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	m_Ecit_Name.GetWindowText(s,255);
	m_ListBox_List.AddString(s);
	m_Ecit_Name.SetWindowText("");
	/******************************
		Add this continent to the
		data base
	******************************/
	if(m_pMap->GetChild() == NULL)
	{
		//----------------------
		// No continents in map
		// YET
		//----------------------
		CMapContinent *pMC;
		pMC = new CMapContinent;
		m_pMap->SetChild(pMC);	//create new continent
		pMC->SetName(s);			//set continent name
		m_Edit_Value.GetWindowText(s,255);
		m_Edit_Value.SetWindowText("");
		pMC->SetValue(atoi(s));
	}
	else	//not the first
	{
		if(m_pContEnd == NULL)	//2nd time thru?
		{
			//find end of chain
			m_pContEnd = (CMapContinent *)m_pMap->GetChild();
			while(m_pContEnd->GetNext())
				m_pContEnd = (CMapContinent *)m_pContEnd->GetNext();
		}
		//create new continent object
		CMapContinent *pMC;
		pMC = new CMapContinent;
		m_pContEnd->SetNext(pMC);
		pMC->SetName(s);			//set continent name
		m_Edit_Value.GetWindowText(s,255);
		m_Edit_Value.SetWindowText("");
		pMC->SetValue(atoi(s));
		m_pContEnd = pMC;
	}
	delete s;
}


void CEditContinents::OnSelchangeListCon()
{
	// TODO: Add your control notification handler code here

	int sel;
	char *s = new char[256];
	CMapContinent *pMC;

	sel = m_ListBox_List.GetCurSel();
	m_ListBox_List.GetText(sel,s);
	m_Ecit_Name.SetWindowText(s);
	pMC = FindContinent(s,(CMapContinent *)m_pMap->GetChild());
	if(pMC)
	{
		///--------------------------------
		/// Put Selected continent name
		/// and data into edit boxes
		///--------------------------------
		sprintf(s,"%d",pMC->GetValue());
		m_Edit_Value.SetWindowText(s);
	}
	delete[] s;
}

void CEditContinents::OnDblclkListCon()
{
	// TODO: Add your control notification handler code here
	///-----------------------------------------
	/// Double clicking on continent
	///name in list box will bring up
	///the Edit Territories Dialog
	///For that continent
	///-----------------------------------------
	int sel;
	char *s = new char[256];

	sel = m_ListBox_List.GetCurSel();
	m_ListBox_List.GetText(sel,s);
	CEditTerritories *pDlg;

	pDlg = new CEditTerritories;
	pDlg->AddContinentName(s);
	pDlg->m_pMC = FindContinent(s,(CMapContinent *)m_pMap->GetChild());
	pDlg->DoModal();	///operate dialog
	delete pDlg;
	delete[] s;

}

CMapContinent * CEditContinents::FindContinent(char *s,CMapContinent *pMC)
{
	/************************************
	** FindContinent
	**
	** This function locates and returns
	** a pointer to a specific continent from
	** a list of continents
	**
	** parameters:
	**	s......name of continent to search for
	** 	pMC....pointer to list of continents
	**
	** Returns:NULL if not found, pointer
	** to continent otherwise.
	******************************************/
	int loop = 1;
	///loop until we find it or run out of data
	while(pMC && loop)
	{
		if(strcmp(s,pMC->GetName()) == 0) loop = 0;
		else
			pMC = (CMapContinent *)pMC->GetNext();
	}
	return pMC;
}

void CEditContinents::OnButtonContUpdate()
{
	// TODO: Add your control notification handler code here
	/****************************************
	** OnButtonUpdate
	**
	** This function is used to update
	** the name in the listbox
	****************************************/
	char *s = new char[256];
	CMapContinent *pMC;
	int sel;

	sel = m_ListBox_List.GetCurSel();
	m_ListBox_List.GetText(sel,s);
	pMC = FindContinent(s,(CMapContinent *)m_pMap->GetChild());
	m_Ecit_Name.GetWindowText(s,255);
	if(pMC)	pMC->SetName(s);
	m_ListBox_List.DeleteString(sel);
	m_ListBox_List.InsertString(sel,s);
	m_Edit_Value.GetWindowText(s,255);
	if(pMC) pMC->SetValue(atoi(s));
	delete[] s;
}

void CEditContinents::OnButtonContDel()
{
	// TODO: Add your control notification handler code here
	/**************************************************
	** OnButtonContDel
	**
	** This function is used to deleete
	** the currently selected continent
	** from both the list box, and the
	** list of Continent MapDataItems
	**************************************************/
	CMapContinent *pMC,*pOMO;
	char *s = new char[256];
	int loop,sel;

	sel = m_ListBox_List.GetCurSel();
	m_ListBox_List.GetText(sel,s);
	pMC = (CMapContinent *)m_pMap->GetChild();
	if(strcmp(s,pMC->GetName())==0)	//first element?
	{
		m_pMap->SetChild(pMC->GetNext());
		delete pMC;
	}
	else
	{
		loop = 1;
		while(pMC && loop)
		{
			if(pMC->GetNext())
			{
				if(strcmp(s,pMC->GetNext()->GetName()) == 0)
				{
					pOMO = (CMapContinent *)pMC->GetNext();
					pMC->SetNext(pOMO->GetNext());
					delete pOMO;
					loop = 0;
				}
				else pMC = (CMapContinent *)pMC->GetNext();
			}
			else loop = 0;
		}
	}
	m_ListBox_List.DeleteString(sel);
	delete[] s;
}

void CEditContinents::OnButtonContDebug()
{
	// TODO: Add your control notification handler code here
	FILE *pO = fopen("DEBUG.TXT","w");
	m_pMap->PrintAll(pO);
	fclose(pO);
}
