// MapInfoDialog.cpp : implementation file
//

#include "stdafx.h"
#include "riskedit.h"
#include "MapInfoDialog.h"
#include "MapContinent.h"
#include "MapTerritory.h"
#include "EditAdjacetTerr.h"
#include "RiskUtils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapInfoDialog dialog


CMapInfoDialog::CMapInfoDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CMapInfoDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapInfoDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	pMap = 0;
}


void CMapInfoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapInfoDialog)
	DDX_Control(pDX, IDC_LIST_INFO_ONEWAYLINK, m_List_OneWayLink);
	DDX_Control(pDX, IDC_STATIC_INFO_ONEWAYLINK, m_Static_OneWayLink);
	DDX_Control(pDX, IDC_LIST_INFO_ISSO, m_List_Isso);
	DDX_Control(pDX, IDC_STATIC_INFO_ISSO, m_Static_Isso);
	DDX_Control(pDX, IDC_LIST_INFO_NOPOLY, m_List_NoPoly);
	DDX_Control(pDX, IDC_STATIC_INFO_TERRITORIES, m_Static_Territories);
	DDX_Control(pDX, IDC_STATIC_INFO_NOPOLY, m_Static_TerrWOPoly);
	DDX_Control(pDX, IDC_STATIC_INFO_CONTINENTS, m_Static_Continents);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapInfoDialog, CDialog)
	//{{AFX_MSG_MAP(CMapInfoDialog)
	ON_LBN_DBLCLK(IDC_LIST_INFO_ISSO, OnDblclkListInfoIsso)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapInfoDialog message handlers

BOOL CMapInfoDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	char *s = new char[256];
	sprintf(s,"%d",pMap->CountContinents());
	m_Static_Continents.SetWindowText(s);

	CMapContinent *pMC;
	CMapTerritory *pMT;
	int nTerr,nTerrWOPoly,nIsso,nOneWay;

	nTerr = 0;		//total territories
	nTerrWOPoly = 0;	//territory without a polygon
	nIsso = 0;		//issolated territories
	nOneWay = 0;	//set one way links to zero
	int x,y;

	pMC = (CMapContinent *)pMap->GetChild();
	while(pMC)
	{
		pMT = (CMapTerritory *)pMC->GetChild();
		while(pMT)
		{
			++nTerr;
			pMT->GetLocation(&x,&y);
			if(x+y == 0)
			{
				++nTerrWOPoly;
				m_List_NoPoly.AddString(pMT->GetName());
			}
			if(pMT->GetNieghborList() == 0)
			{
				++nIsso;
				m_List_Isso.AddString(pMT->GetName());
			}
			if(CheckForOneWayLinks(pMT))
			{
				nOneWay++;
				m_List_OneWayLink.AddString(pMT->GetName());
			}
			pMT = (CMapTerritory *)pMT->GetNext();
		}
		pMC = (CMapContinent *)pMC->GetNext();
	}
	sprintf(s,"%d",nTerr);
	m_Static_Territories.SetWindowText(s);
	sprintf(s,"%d",nTerrWOPoly);
	m_Static_TerrWOPoly.SetWindowText(s);
	sprintf(s,"%d",nIsso);
	m_Static_Isso.SetWindowText(s);
	sprintf(s,"%d",nOneWay);
	m_Static_OneWayLink.SetWindowText(s);
	delete[] s;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMapInfoDialog::OnDblclkListInfoIsso() 
{
	// TODO: Add your control notification handler code here
	char *s = new char[256];
	CMapTerritory *pMT;
	CMapContinent *pMC;

	int sel = m_List_Isso.GetCurSel();
	m_List_Isso.GetText(sel,s);	//get name of territory
	pMT = FindTerritory(pMap,s);
	pMC = FindContinent(pMap,pMT);
	CEditAdjacetTerr Dlg;
	Dlg.m_pMC_Init = pMC;
	Dlg.m_pMT_Init = pMT;
	Dlg.m_pMap = pMap;
	Dlg.DoModal();

	delete[] s;
}

int CMapInfoDialog::CheckForOneWayLinks(CMapTerritory *pMT)
{
	CTerrList *pTL,*pTLadj;
	CMapTerritory *pMTadj;
	int linkflag;
	int terrcount;
	int loop2;
	int rv = 1;	//assume one way link
	pTL = pMT->GetNieghborList();	//get list of adjacent territories
	terrcount = 0;
	linkflag = 0;
	while(pTL)
	{
		terrcount++;
		pMTadj = pTL->GetTerr();
		pTLadj = pMTadj->GetNieghborList();
		loop2 = 1;
		while(pTLadj && loop2)
		{
			if(pTLadj->GetTerr() == pMT)	//reciprocal link?
			{
				linkflag++;
				loop2 = 0;
			}
			else
				pTLadj = pTLadj->GetNext();
		}
		pTL = pTL->GetNext();
	}
	if(linkflag == terrcount) rv = 0;	//indicate no one way links
	return rv;
}
