// RiskEditDoc.cpp : implementation of the CRiskEditDoc class
//

#include "stdafx.h"
#include "RiskEdit.h"

#include "RiskEditDoc.h"
#include "LoadCreateMap.h"
#include "MapProperties.h"
#include "EditContinents.h"
#include "MainFrm.h"
#include "RiskEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRiskEditDoc

IMPLEMENT_DYNCREATE(CRiskEditDoc, CDocument)

BEGIN_MESSAGE_MAP(CRiskEditDoc, CDocument)
	//{{AFX_MSG_MAP(CRiskEditDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRiskEditDoc construction/destruction

CRiskEditDoc::CRiskEditDoc()
{
	// TODO: add one-time construction code here
	m_pMAP = 0;
	m_pMapData = 0;
	m_DoLoad = 0;
	m_pPolyList = 0;
	m_pPolyEnd = 0;
}

CRiskEditDoc::~CRiskEditDoc()
{
}

BOOL CRiskEditDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	int Load;

	m_pMAP = new CMyBitmap;
	m_pMAP->CreateBitmap(3600,2250,1,32,0);
	CLoadCreateMap *pDlg = new CLoadCreateMap;
	pDlg->DoModal();
	Load = pDlg->m_Load;
	delete pDlg;
	if(Load)	//load from a file
	{
		m_DoLoad = 1;
		return TRUE;
	}
	else
	{
		CMapProperties *pMPDlg = new CMapProperties;
		m_pMapData = new CMap;
		pMPDlg->m_pMap = m_pMapData;	//attatch map of dialog
		m_pMapData->SetMapWidth(3600);	//set default map hieght
		m_pMapData->SetMapHieght(2250);	//and width
		m_pMapData->SetName("World");	//set default name
		m_pMapData->SetMerEnd(190);		//meridian on right of map
		m_pMapData->SetMerLineWidth(1);	//line width
		m_pMapData->SetMerSpacing(20);	//meridian spacing is 20 degrees
		m_pMapData->SetMerStart(-170);	//meridian on left side of map
		m_pMapData->SetLogEnd(-70);		//logitude of bottom of map
		m_pMapData->SetLogLineWidth(1);	//size of logitude line
		m_pMapData->SetLogSpacing(10);	//space longitude by 10 degrees
		m_pMapData->SetLogStart(70);	//logitiude of top of map
		pMPDlg->DoModal();
		delete pMPDlg;
		CEditContinents *pCEDlg = new CEditContinents;
		pCEDlg->m_pMap = m_pMapData;
		pCEDlg->DoModal();
		delete pCEDlg;
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CRiskEditDoc serialization

void CRiskEditDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRiskEditDoc diagnostics

#ifdef _DEBUG
void CRiskEditDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRiskEditDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRiskEditDoc commands

void CRiskEditDoc::SaveBitmap(FILE *pO)
{
	/************************************
	** SaveBitmap
	**
	** This function is used to save
	** a bitmap to a file
	**
	** parameter:
	** pO.......pointer to file to save bitmap
	************************************/
	BITMAPFILEHEADER BmHdr;
	BITMAP Bm;
	BITMAPINFOHEADER BmIHdr;
	unsigned int FileSize;
	char *pBMbuf;

	CBitmap *pBM = this->m_pMAP;
	pBM->GetBitmap(&Bm);
	FileSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	BmHdr.bfType = (WORD)('B' | 'M'<<8);
	BmHdr.bfReserved2 = 0;
	BmHdr.bfReserved1 = 0;
	BmHdr.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	memset(&BmIHdr,0,sizeof(BITMAPINFOHEADER));
	BmIHdr.biSize = sizeof(BITMAPINFOHEADER);
	BmIHdr.biHeight = Bm.bmHeight;
	BmIHdr.biWidth = Bm.bmWidth;
	BmIHdr.biBitCount = Bm.bmBitsPixel;
	BmIHdr.biCompression = BI_RGB;	//not compressed
	BmIHdr.biPlanes = Bm.bmPlanes;
	BmIHdr.biSizeImage = Bm.bmHeight * Bm.bmWidth * Bm.bmBitsPixel / 8;

	BmHdr.bfSize = FileSize + BmIHdr.biSizeImage;
	pBMbuf = new char[BmIHdr.biSizeImage];
	pBM->GetBitmapBits(BmIHdr.biSizeImage,pBMbuf);
	fwrite(&BmHdr,1,sizeof(BITMAPFILEHEADER),pO);
	fwrite(&BmIHdr,1,sizeof(BITMAPINFOHEADER),pO);
	unsigned i;
	unsigned LineSize = Bm.bmWidth * Bm.bmBitsPixel / 8;
	char *pC = &pBMbuf[BmIHdr.biSizeImage-LineSize];
	unsigned count = BmIHdr.biSizeImage /4;
	count /= Bm.bmWidth;
	for(i=0;i< count;++i)
	{
		fwrite(pC,1,LineSize,pO);
		pC -= LineSize;
	}
	delete[] pBMbuf;
}

void CRiskEditDoc::AddPolygon(CPolygon *pP)
{
	CPolygon *pNew = new CPolygon();
	pNew->Copy(pP);
	if(m_pPolyList)
	{
		m_pPolyEnd->SetNext(pNew);
		m_pPolyEnd = pNew;
	}
	else
	{
		m_pPolyList = pNew;
		m_pPolyEnd = pNew;
	}

}

void CRiskEditDoc::SavePolygons(FILE *pO)
{
	CPolygon *pP = m_pPolyList;

	while(pP)
	{
		pP->Print(pO);
		pP = pP->GetNext();
	}
}

int CRiskEditDoc::DeletePolygon(CPolygon *pPoly)
{
	CPolygon *pL = m_pPolyList;
	CPolygon *pPrev = NULL;
	int rv = 0;

	while(pL && !rv)
	{
		if(pL == pPoly)	//this is the one to delete
		{
			rv = 1;	//found the little bastard
			if(pPrev == NULL)
			{
				m_pPolyList = m_pPolyList->GetNext();
			}
			else
			{
				if(pL->GetNext())
					pPrev->SetNext(pL->GetNext());
				else
				{
					pPrev->SetNext(0);
					this->m_pPolyEnd = pPrev;
				}
			}
			delete pL;
		}
		else
		{
			pPrev = pL;
			pL = pL->GetNext();
		}
	}
	return rv;
}
