// RiskEditView.h : interface of the CRiskEditView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RISKEDITVIEW_H__A1736911_9659_4C4F_B862_520C21DF43CE__INCLUDED_)
#define AFX_RISKEDITVIEW_H__A1736911_9659_4C4F_B862_520C21DF43CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AutoScrollView.h"
#include "Polygon.h"

//-------------------------
// Drawing tool defines
//-------------------------

#define TOOL_DRAW		0
#define TOOL_FILL		1
#define TOOL_ERASE		2
#define TOOL_BORDER		3
#define TOOL_POLYGON	4
#define TOOL_ASSING		5
#define TOOL_CONNECT	6

#define TIMEREVENT_LMB		100
#define TIMEREVENT_RMB		101
#define TIMEREVENT_SCROLL	102

class CRiskEditDoc;

class CRiskEditView : public CAutoScrollView
{
	friend CRiskEditDoc;
protected: // create from serialization only
	CRiskEditView();
	DECLARE_DYNCREATE(CRiskEditView)

// Attributes
public:
	CRiskEditDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRiskEditView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual void OnAutoScroll(CPoint point, BOOL bBeforeScroll);
	FILE * pDB;
	int m_TimerScroll;
	int m_AutoScrollMode;
	int AssignTerrToPoly(CPoint nP);
	void DrawPolyLine(CDC *pDC,CPolygon *pP);
	int m_DrawPenSize;
	int Compile(CMap *pMap);
	CMapTerritory * FindTerritory(CMap *pM,char *s);
	char * GenBitMapName(void);
	char * GenMapDataName(void);
	void ProcesFileName(char *name);
	int m_PolyView;
	CPolygon * ParsePolygon(FILE *pI,CMap *pM);
	int m_Timer_MB_RightFlag;
	int m_Timer_MB_LeftFlag;
	int m_Timer_MB_RightID;
	int m_Timer_MB_LeftID;
	void DrawPoly(CDC *pDC,CPolygon *pP);
	int m_PolyState;
	int m_LineRubberband;
	CPoint m_LineEnd;
	CPoint m_LineStart;
	CPoint m_MouseDownPoint;
	CPolygon m_scrPoly;
	int m_LineEraseFlag;
	char * m_pBMfileName;
	char * m_pPathName;
	char * m_pFileName;
	int Expect(int Tv, int LAH);
	COLORREF m_BkgColor;
	COLORREF m_BorderColor;
	int m_CurTool;
	COLORREF m_CurColor;
	int m_nBmpWidth,m_nBmpHeight;
	CDC m_MemDC;
	CBrush m_CurrentBrush;
	CPen m_CurrentPen;
	int m_Line;
	int m_LookAHead;
	int m_TokenValue;
	char * m_pLexBuff;
	int GetChar(FILE *pI);
	CMap * LoadMapData(FILE *pI);
	int m_EraseBKG;
	CPoint m_LastPoint;
	int m_MouseDown;
	virtual ~CRiskEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRiskEditView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileOpen();
	afx_msg void OnEditContinent();
	afx_msg void OnEditMeridians();
	afx_msg void OnEditDebug();
	afx_msg void OnEditColor();
	afx_msg void OnDrawTool();
	afx_msg void OnFillTool();
	afx_msg void OnErase();
	afx_msg void OnBordersTool();
	afx_msg void OnButtonPolygon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnViewPolygons();
	afx_msg void OnButtonAssign();
	afx_msg void OnButtonConnect();
	afx_msg void OnLargedot();
	afx_msg void OnMediumdot();
	afx_msg void OnSmalldot();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnUpdateOneGetcolor(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOneDelPoly(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOneAssign(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOneLinkTerr(CCmdUI* pCmdUI);
	afx_msg void OnCancelMode();
	afx_msg void OnMenuViewAutoscroll();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMenuInfoStats();
	afx_msg void OnMenuEditUdatecolors();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int Lookup(char *s);
	CMap *Parser(FILE *pI);
	CMapTerritory * ParseTerritory(FILE *pI);
	CMapContinent * ParseContinent(FILE *pI);
	void Error(char *s);
	int m_Unget_Buffer;
	int match(FILE *pI,int token);
	int Lexer(FILE *pI);
};

#ifndef _DEBUG  // debug version in RiskEditView.cpp
inline CRiskEditDoc* CRiskEditView::GetDocument()
   { return (CRiskEditDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RISKEDITVIEW_H__A1736911_9659_4C4F_B862_520C21DF43CE__INCLUDED_)
